Index: trunk/SophyaProg/Tests/carrt.cc
===================================================================
--- trunk/SophyaProg/Tests/carrt.cc	(revision 1119)
+++ trunk/SophyaProg/Tests/carrt.cc	(revision 1161)
@@ -76,5 +76,4 @@
      ra = ia;
      cout << " ra = ia(= RegularSequence(10., 2.)) = \n " << ra << endl;
-     cout << ra << endl;  
      TArray<r_4> rb(5,3);
      rb =  RegularSequence(20., .5);  
Index: trunk/SophyaProg/Tests/timg.cc
===================================================================
--- trunk/SophyaProg/Tests/timg.cc	(revision 1119)
+++ trunk/SophyaProg/Tests/timg.cc	(revision 1161)
@@ -3,4 +3,5 @@
 // Utilisation de la classe Image<T>
 #include "ntoolsinit.h"
+#include "array.h"
 #include "cimage.h"
 // Utilisation des generateurs aleatoires
@@ -18,5 +19,7 @@
 {
 int i,j;
+double mean,sig;
 
+try {
 // ----- ATTENTION -------
 // Initialisation de Sophya
@@ -32,8 +35,13 @@
   for(j=0; j<200; j++) img(i,j) = imgo(i,j) =  frand01()*1000.+1000.;
 // Verification de la dynamique de l'image
-img.CheckDyn();
-img.Print();
+MeanSigma(img, mean, sig);
+cout << " img: Mean= " << mean << " Sigma= " << sig << endl;
+cout << img ; 
+
 // On sauve l'image ds img.ppf (fichier  format PPersist)
-img.Write("img.ppf");
+{
+POutPersist po("img.ppf");
+po << img;
+}
 
 // On rajoute du bruit a l'image (Gaussienne de sigma=3)
@@ -42,6 +50,6 @@
 
 // Verification de la dynamique de l'image
-img.CheckDyn();
-img.Print();
+MeanSigma(img, mean, sig);
+cout << "ApresNoise img: Mean= " << mean << " Sigma= " << sig << endl;
 
 // On verifie la date de creation du fichier .ppf
@@ -52,8 +60,13 @@
        << " Created: " << pin.CreationDate() << endl;
   }
+
 // On cree une nouvelle image 
 ImageR4  img2;
 // On lit le contenu du fichier imgin.ppf
-img2.Read("img.ppf");
+{
+PInPersist pi("img.ppf");
+pi >> img2;
+}
+
 // On calcule la difference entre les images img et img2
 //    Avant ajout de bruit
@@ -61,13 +74,16 @@
 imgo -= img2;
 // Verification de la dynamique de l'image soustraite
-imgo.CheckDyn();
-imgo.Print();
+r_4 min,max;
+imgo.MinMax(min, max);
+cout << " Min(imgo) = " << min << " Max(imgo) = " << max << endl;
 
 //    Apres  ajout de bruit
-cout << " img(avecbruit) - img2 (fromfile) == Noise, sigma=1 ? " << endl;
+cout << " img(avecbruit) - img2 (fromfile) == Noise, sigma=3 ? " << endl;
 img -= img2;
 // Verification de la dynamique de l'image soustraite
-img.CheckDyn();
-img.Print();
+imgo.MinMax(min, max);
+cout << " Min(img) = " << min << " Max(img) = " << max << endl;
+MeanSigma(img, mean, sig);
+cout << "Apres img -= img2 img: Mean= " << mean << " Sigma= " << sig << endl;
 
 // ---- Test des NDataBlock 
@@ -110,4 +126,14 @@
 st = typeid(irp).name();
 cout << "typeid(irp).name() - " << st << endl;
+}
+
+catch (PThrowable & exc) {
+  cerr << "timg/Error Catched Exception " << (string)typeid(exc).name() 
+       << " - Msg= " << exc.Msg() << endl;
+}
+catch (...) {
+  cerr << "timg/Error some other exception was caught ! " << endl;
+}
+
 cout << "\n ========= Fin de timg.cc ======== " << endl;
 exit(0);
Index: trunk/SophyaProg/Tests/tnt.cc
===================================================================
--- trunk/SophyaProg/Tests/tnt.cc	(revision 1119)
+++ trunk/SophyaProg/Tests/tnt.cc	(revision 1161)
@@ -58,4 +58,6 @@
      nt1.Fill(xnt); k++; }
 
+ nt1.Info().Comment() = "NTuple de Test - Cree par tnt.cc";
+ nt1.Info()["Version"] = SophyaVersion();
  nt1.Show(cout);
  nt1.Print(0, 5);
@@ -89,5 +91,18 @@
 DVList dvl;
 
-cout << "\n ======= test_dvl:  Testing DVList ======= " << endl;
+cout << "\n ======= test_dvl:  Testing MuTyV ======= " << endl;
+MuTyV zvs = " ( 1.41 -2.71) ";
+MuTyV dvs = "434.898";
+MuTyV fvu = 314.1596;
+MuTyV ivu = 7654321;
+cout << " float->string: fvu= " << fvu << " (string)fvu=" << (string)fvu << endl;
+cout << " int->string: ivu= " << ivu << " (string)ivu=" << (string)ivu << endl;
+cout << "String->complex<double>: zvs = " << zvs 
+     << " (complex<double>)zvs= " << (complex<double>)zvs << endl;
+cout << "String->double: dvs = " << dvs 
+     << " (double)zvs= " << (double)dvs << endl;
+
+
+cout << "\n\n ======= test_dvl:  Testing DVList ======= " << endl;
 dvl.SetI("Var XXX", 12345);
 dvl.SetI("IV1-80", 80);
@@ -109,5 +124,8 @@
 dvl.SetComment("IntegerValue", "This variable has a comment");
 dvl.Comment() = "This is a test DVL produced by the program tdvl.cc \n Using SOPHYA , Feb 2000";
+
+dvl["Sinf"] = "inf 0985";
 dvl.Print();
+
 
 double d = dvl("DV2-4.5");